﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace i8012W_Basic_Csharp
{
    public partial class i8012W_Basic_Info : Form
    {
        short slot = 0;
        short FarmVer = 0;
        short LibVer = 0;
        string LibDate = "";
        short range = -1;

        private string[] RangeStr = new string[2];
        private string[] SlotStr = new string[9];
        public i8012W_Basic_Info()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            Description_list.Items.Add("This demo tells the Analog Input function.");
            Description_list.Items.Add("Please follow the below steps.");
            Description_list.Items.Add("1. Select slot");

            RangeStr[0] = "+/- 5V";
            RangeStr[1] = "+/- 10V";

            SlotStr[0] = "Slot 0";
            SlotStr[1] = "Slot 1";
            SlotStr[2] = "Slot 2";
            SlotStr[3] = "Slot 3";
            SlotStr[4] = "Slot 4";
            SlotStr[5] = "Slot 5";
            SlotStr[6] = "Slot 6";
            SlotStr[7] = "Slot 7";
            SlotStr[8] = "Auto Search";

            for (i = 0; i < 2; i++)
            {
                Range_cbo.Items.Add(RangeStr[i]);
            }
            for (i = 0; i < 9; i++)
            {
                Slot_cbo.Items.Add(SlotStr[i]);
            }
            LibVer = pac8012WNet.pac8012W.LibVersion();
            LibVer_txt.Text = LibVer.ToString("X");
            LibDate = pac8012WNet.pac8012W.LibDate();
            LibDate_txt.Text = LibDate;
        }

        private void Slot_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = 0;
            short i = 0;
            string msg = "";
            slot = (short)Slot_cbo.SelectedIndex;
            if (slot == 8)
            {
                for (i = 0; i < 8; i++)
                {
                    ret = pac8012WNet.pac8012W.Init(i);
                    if (ret == 0)
                    {
                        slot = i;
                        msg = string.Format("Find Module on slot {0}", slot);
                        MessageBox.Show(msg);
                        break;
                    }
                }
                if (slot == 8)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            else
            {
                ret = pac8012WNet.pac8012W.Init(slot);
                if (ret != 0)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            FarmVer = pac8012WNet.pac8012W.FirmwareVersion(slot);
            FirmVer_txt.Text = FarmVer.ToString();
            Description_list.Items.Add("2. Select Range");
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Range_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            short ch = 0;
            ushort gainval = 0;
            short offsetval = 0;

            Label[] labGainarr = new Label[8];
            Label[] labOffsetarr = new Label[8];

            labGainarr[0] = C0G_lab;
            labGainarr[1] = C1G_lab;
            labGainarr[2] = C2G_lab;
            labGainarr[3] = C3G_lab;
            labGainarr[4] = C4G_lab;
            labGainarr[5] = C5G_lab;
            labGainarr[6] = C6G_lab;
            labGainarr[7] = C7G_lab;

            labOffsetarr[0] = C0O_lab;
            labOffsetarr[1] = C1O_lab;
            labOffsetarr[2] = C2O_lab;
            labOffsetarr[3] = C3O_lab;
            labOffsetarr[4] = C4O_lab;
            labOffsetarr[5] = C5O_lab;
            labOffsetarr[6] = C6O_lab;
            labOffsetarr[7] = C7O_lab;

            range = (short)Range_cbo.SelectedIndex;

            for (ch = 0; ch < 8; ch++)
            {
                pac8012WNet.pac8012W.ReadGainOffset(slot, ch, range, ref gainval, ref offsetval);
                labGainarr[ch].Text = Convert.ToString(gainval);
                labOffsetarr[ch].Text = Convert.ToString(offsetval);
                Application.DoEvents();
            }

            Description_list.Items.Add("3. Click 'Read AI' button");
        }

        private void btnAIHex_Click(object sender, EventArgs e)
        {
            TextBox[] txtAIarr = new TextBox[8];
            short ch = 0;
            float AIval = 0;

            txtAIarr[0] = AI0_txt;
            txtAIarr[1] = AI1_txt;
            txtAIarr[2] = AI2_txt;
            txtAIarr[3] = AI3_txt;
            txtAIarr[4] = AI4_txt;
            txtAIarr[5] = AI5_txt;
            txtAIarr[6] = AI6_txt;
            txtAIarr[7] = AI7_txt;

            for (ch = 0; ch < 8; ch++)
            {
                pac8012WNet.pac8012W.ReadAI(slot, ch, range, ref AIval);
                txtAIarr[ch].Text = Convert.ToString(AIval);
                Application.DoEvents();
            }
        }
    }
}