﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace i8012W_MagicScan_NonBlock_Csharp
{
    public partial class i8012_MagicScan_NonBlock : Form
    {
        [System.Runtime.InteropServices.DllImport("coredll.dll")]
        private static extern uint GetModuleFileName(IntPtr hModule, System.Text.StringBuilder lpFileName, int nSize);

        int slot = 0;
        int range = -1;
        int chcnt = 0;
        int trigmode = -1;
        int ext_source = -1;

        short FarmVer = 0;
        short LibVer = 0;
        string LibDate = "";


        short read_count = 0;
        UInt32 target_count = 0;
        UInt32 DataCount = 0;
        UInt32 total_count = 0;

        short[] FIFOData = new short[2100];
        short[] RawData = new short[80000];
        short[,] HexData = new short[8, 10000];
        float[,] floatData = new float[8, 10000];

        private string[] SlotStr = new string[9];
        private string[] RangeStr = new string[2];
        private string[] ChCntStr = new string[8];
        private string[] TrigStr = new string[2];
        private string[] SourceStr = new string[2];

        public i8012_MagicScan_NonBlock()
        {
            InitializeComponent();
        }

        private void i8012_MagicScan_NonBlock_Load(object sender, EventArgs e)
        {
            int i = 0;
            Description_list.Items.Add("This demo tells the Magic Scan function.");
            Description_list.Items.Add("Please follow the below steps.");
            Description_list.Items.Add("1. Select slot");

            SlotStr[0] = "Slot 0";
            SlotStr[1] = "Slot 1";
            SlotStr[2] = "Slot 2";
            SlotStr[3] = "Slot 3";
            SlotStr[4] = "Slot 4";
            SlotStr[5] = "Slot 5";
            SlotStr[6] = "Slot 6";
            SlotStr[7] = "Slot 7";
            SlotStr[8] = "Auto Search";

            RangeStr[0] = "+/- 5V";
            RangeStr[1] = "+/- 10V";

            ChCntStr[0] = "1 Channel";
            ChCntStr[1] = "2 Channels";
            ChCntStr[2] = "3 Channels";
            ChCntStr[3] = "4 Channels";
            ChCntStr[4] = "5 Channels";
            ChCntStr[5] = "6 Channels";
            ChCntStr[6] = "7 Channels";
            ChCntStr[7] = "8 Channels";

            TrigStr[0] = "Internal Trigger";
            TrigStr[1] = "External Trigger";

            SourceStr[0] = "Trig-Output Pin";
            SourceStr[1] = "Other device";

            for (i = 0; i < 9; i++)
            {
                Slot_cbo.Items.Add(SlotStr[i]);
            }
            for (i = 0; i < 2; i++)
            {
                Range_cbo.Items.Add(RangeStr[i]);
            }
            for (i = 0; i < 8; i++)
            {
                ChCnt_cbo.Items.Add(ChCntStr[i]);
            }
            for (i = 0; i < 2; i++)
            {
                Trig_cbo.Items.Add(TrigStr[i]);
            }
            for (i = 0; i < 2; i++)
            {
                Source_cbo.Items.Add(SourceStr[i]);
            }

            LibVer = pac8012WNet.pac8012W.LibVersion();
            LibVer_txt.Text = LibVer.ToString("X");
            LibDate = pac8012WNet.pac8012W.LibDate();
            LibDate_txt.Text = LibDate;
        }

        private void Slot_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = 0;
            short i = 0;
            string msg = "";
            slot = Slot_cbo.SelectedIndex;
            if (slot == 8)
            {
                for (i = 0; i < 8; i++)
                {
                    ret = pac8012WNet.pac8012W.Init(i);
                    if (ret == 0)
                    {
                        slot = i;
                        msg = string.Format("Find Module on slot {0}", slot);
                        MessageBox.Show(msg);
                        break;
                    }
                }
                if (slot == 8)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            else
            {
                ret = pac8012WNet.pac8012W.Init(slot);
                if (ret != 0)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            FarmVer = pac8012WNet.pac8012W.FirmwareVersion(slot);
            FirmVer_txt.Text = FarmVer.ToString();
            Description_list.Items.Add("2. Select Range");
        }

        private void Range_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            range = Range_cbo.SelectedIndex;
            Description_list.Items.Add("3. Select Channel Count");
        }

        private void ChCnt_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            chcnt = ChCnt_cbo.SelectedIndex + 1;
            Description_list.Items.Add("4. Select Trig Mode");
        }

        private void Trig_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            trigmode = Trig_cbo.SelectedIndex;
            if (trigmode == 0)
            {
                Source_lab.Enabled = false;
                Source_lab.Visible = false;
                Source_cbo.Enabled = false;
                Source_cbo.Visible = false;
                Description_list.Items.Add("5. Input Sample Rate and Target Count");
                Description_list.Items.Add("Sample Rate 20 ~ 200000 Hz");
                Description_list.Items.Add("Target Count : 1 ~ 10000");
            }
            else
            {
                Source_lab.Enabled = true;
                Source_lab.Visible = true;
                Source_cbo.Enabled = true;
                Source_cbo.Visible = true;
                Description_list.Items.Add("5. Select External Source");
            }
        }

        private void Source_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            ext_source = Source_cbo.SelectedIndex;
            Description_list.Items.Add("Please make sure the External signal is connected with Trig-Input Pin");
            if (ext_source == 0)
            {
                Description_list.Items.Add("6. Input Sample Rate and Target Count");
                Description_list.Items.Add("Sample Rate 20 ~ 200000 Hz");
                Description_list.Items.Add("Target Count : 1 ~ 10000");
            }
            else
            {
                Description_list.Items.Add("Please adjust the frequency of the external source");
                Description_list.Items.Add("And Input Target Count");
                Description_list.Items.Add("Sample Rate 20 ~ 200000 Hz");
                Description_list.Items.Add("Target Count : 1 ~ 10000");
            }
        }

        private void Set_btn_Click(object sender, EventArgs e)
        {
            UInt32 sample_rate = 0;
            UInt32 real_rate = 0;
            sample_rate = Convert.ToUInt32(Sample_Rate_txt.Text);
            pac8012WNet.pac8012W.ConfigMagicScan(slot, range, chcnt, trigmode, sample_rate, ref real_rate);
            if (trigmode == 0)
            {
                Description_list.Items.Add("7. Click 'Start' button");
            }
            else
            {
                if (ext_source == 0)
                {
                    Description_list.Items.Add("8. Click 'Start' button");
                }
                else
                {
                    Description_list.Items.Add("8. Output external signal and click 'Start' button");
                }
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            bool flag = false;
            int ret = 0;
            int i = 0;
            target_count = Convert.ToUInt32(Target_Count_txt.Text);
            RawData = new short[target_count];

            pac8012WNet.pac8012W.StartMagicScan(slot);
            if (trigmode == 1)
            {
                if (ext_source == 0)
                {
                    pac8012WNet.pac8012W.EnableTrigOut(slot);
                }
            }
            flag = true;
            total_count = 0;
            while (flag)
            {
                ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, target_count - total_count, ref read_count);
                if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                {
                    pac8012WNet.pac8012W.StopMagicScan(slot);
                    if (trigmode == 1)
                    {
                        if (ext_source == 0)
                        {
                            pac8012WNet.pac8012W.DisableTrigOut(slot);
                        }
                    }

                    MessageBox.Show("FIFO Full! Please use a lower rate and try again.");
                    return;
                }
                if (ret == (int)pac8012WNet.ErrorCode.NoError)
                {
                    for (i = 0; i < read_count; i++)
                        RawData[i + total_count] = FIFOData[i];
                    total_count += (UInt32)read_count;
                    if (total_count >= target_count)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);
                        if (trigmode == 1)
                        {
                            if (ext_source == 0)
                            {
                                pac8012WNet.pac8012W.DisableTrigOut(slot);
                            }
                        }
                        flag = false;
                    }
                }
            }
            Show_AI();
        }
        void Show_AI()
        {
            int ch = 0;
            UInt32 i = 0;
            string Msg = "";
            if ((target_count % chcnt) != 0)
                DataCount = (UInt32)((target_count / chcnt) + 1);
            else
                DataCount = (UInt32)(target_count / chcnt);

            HexData = new short[chcnt, DataCount];
            floatData = new float[chcnt, DataCount];
            for (i = 0; i < DataCount; i++)
            {
                for (ch = 0; ch < chcnt; ch++)
                {
                    if ((i * chcnt + ch) >= target_count)
                    {
                        HexData[ch, i] = 0;
                        floatData[ch, i] = 0;
                    }
                    else
                    {
                        pac8012WNet.pac8012W.CalibrationHEX(slot, ch, range, RawData[i * chcnt + ch], ref HexData[ch, i]);
                        pac8012WNet.pac8012W.CalibrationFloat(slot, ch, range, RawData[i * chcnt + ch], ref floatData[ch, i]);
                    }
                    Application.DoEvents();
                }
            }

            for (i = 0; i < DataCount; i++)
            {
                Msg = "[" + i.ToString("000") + "] ";
                for (ch = 0; ch < chcnt; ch++)
                {
                    if (ch % chcnt == chcnt - 1)
                        Msg += "CH_" + ch.ToString() + " " + HexData[ch, i].ToString("X") + " " + floatData[ch, i].ToString("00.000");
                    else
                        Msg += "CH_" + ch.ToString() + " " + HexData[ch, i].ToString("X") + " " + floatData[ch, i].ToString("00.000") + ",";
                }
                Data_list.Items.Add(string.Format(Msg));
                Application.DoEvents();
            }
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Clear_Desc_btn_Click(object sender, EventArgs e)
        {
            Description_list.Items.Clear();
        }

        private void Clear_Data_btn_Click(object sender, EventArgs e)
        {
            Data_list.Items.Clear();
        }

        private void Save_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            UInt32 i = 0;
            string fPath = GetAppPath() + "\\SampleData" + ".txt";
            string data = string.Empty;
            Description_list.Items.Add(fPath);
            StreamWriter Dsw = new StreamWriter(fPath, false, System.Text.Encoding.Default);
            Dsw.WriteLine("HEX Format");
            for (i = 0; i < DataCount; i++)
            {
                data = string.Empty;
                for (ch = 0; ch < chcnt; ch++)
                {
                    if (ch % chcnt == chcnt - 1)
                        data += HexData[ch, i].ToString("X");
                    else
                        data += HexData[ch, i].ToString("X") + ", ";
                }
                Dsw.WriteLine(data);
            }
            Dsw.WriteLine("Float Format");
            for (i = 0; i < DataCount; i++)
            {
                data = string.Empty;
                for (ch = 0; ch < chcnt; ch++)
                {
                    if (ch % chcnt == chcnt - 1)
                        data += floatData[ch, i].ToString("00.000");
                    else
                        data += floatData[ch, i].ToString("00.000") + ",";
                }
                Dsw.WriteLine(data);
            }
            Dsw.Flush();
            Dsw.Close();
        }
        private string GetAppPath()
        {
            int iStart = 0;
            string csCurDir = "";
            System.Text.StringBuilder STRBER = new System.Text.StringBuilder(256);
            if (GetModuleFileName(IntPtr.Zero, STRBER, STRBER.Capacity) > 0)
                csCurDir = STRBER.ToString();
            else
                return string.Empty;
            while (!csCurDir.EndsWith(@"\"))
            {
                iStart = csCurDir.Length - 1;
                csCurDir = csCurDir.Remove(iStart, 1);
            }
            return csCurDir;
        }
    }
}