﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace i8012W_Multi_Modules_Scan_Csharp
{
    public partial class i8012_Multi_Modules_Scan : Form
    {
        [System.Runtime.InteropServices.DllImport("coredll.dll")]
        private static extern uint GetModuleFileName(IntPtr hModule, System.Text.StringBuilder lpFileName, int nSize);

        bool flag = false;
        int Master_Card = -1;
        short FarmVer = 0;
        short LibVer = 0;
        string LibDate = "";

        int trigmode = 1;// 1 : External Trig Mode
        int ext_source = -1;
        UInt32 sample_rate = 0;

        int slotcnt = 0;
        int[] slotarr = new int[8];
        int[] rangearr = new int[8];
        int[] chcntarr = new int[8];
        UInt32[] targetarr = new UInt32[8];

        short[][] RawData = new short[8][];
        short[][][] HexData = new short[8][][];
        float[][][] floatData = new float[8][][];
        UInt32[] totalcount = new UInt32[8];
        int[] threadstatusarr = new int[8];

        private string[] SlotStr = new string[8];
        private string[] RangeStr = new string[2];
        private string[] ChCntStr = new string[8];
        private string[] SourceStr = new string[2];


        CheckBox[] enable_arr = new CheckBox[8];
        Label[] farm_arr = new Label[8];
        ComboBox[] range_arr = new ComboBox[9];
        ComboBox[] chcnt_arr = new ComboBox[9];
        TextBox[] target_arr = new TextBox[8];

        bool[] Thread_flag = new bool[8];
        ThreadStart[] myThreads = new ThreadStart[8];
        Thread[] Threads = new Thread[8];

        public i8012_Multi_Modules_Scan()
        {
            InitializeComponent();
        }

        private void i8012_Multi_Modules_Scan_Load(object sender, EventArgs e)
        {
            int i = 0;
            int j = 0;

            Description_list.Items.Add("This demo shows Multi-Modules Scan function.");
            Description_list.Items.Add("Please follow steps below.");
            Description_list.Items.Add("1.Check the modules those on the backplane.");
            Description_list.Items.Add("  or click 'Auto Search' button to find all the modules.");
            Description_list.Items.Add("2.Set range,channel count,target count for each module.");
            Description_list.Items.Add("target count : 1 ~ 10000");
            Description_list.Items.Add("3.Select external source type.");

            //////////////////////////////////////
            SlotStr[0] = "Slot 0";
            SlotStr[1] = "Slot 1";
            SlotStr[2] = "Slot 2";
            SlotStr[3] = "Slot 3";
            SlotStr[4] = "Slot 4";
            SlotStr[5] = "Slot 5";
            SlotStr[6] = "Slot 6";
            SlotStr[7] = "Slot 7";
            //////////////////////////////////////
            range_arr[0] = Range0_cbo;
            range_arr[1] = Range1_cbo;
            range_arr[2] = Range2_cbo;
            range_arr[3] = Range3_cbo;
            range_arr[4] = Range4_cbo;
            range_arr[5] = Range5_cbo;
            range_arr[6] = Range6_cbo;
            range_arr[7] = Range7_cbo;
            range_arr[8] = RangeAll_cbo;


            RangeStr[0] = "+/- 5V";
            RangeStr[1] = "+/- 10V";

            for (i = 0; i < 9; i++)
            {
                for (j = 0; j < 2; j++)
                {
                    range_arr[i].Items.Add(RangeStr[j]);
                }
            }
            for (i = 0; i < 8; i++)
            {
                this.range_arr[i].SelectedIndexChanged += new System.EventHandler(this.Range_SelectedIndexChanged);
            }
            //////////////////////////////////////
            chcnt_arr[0] = ChCnt0_cbo;
            chcnt_arr[1] = ChCnt1_cbo;
            chcnt_arr[2] = ChCnt2_cbo;
            chcnt_arr[3] = ChCnt3_cbo;
            chcnt_arr[4] = ChCnt4_cbo;
            chcnt_arr[5] = ChCnt5_cbo;
            chcnt_arr[6] = ChCnt6_cbo;
            chcnt_arr[7] = ChCnt7_cbo;
            chcnt_arr[8] = ChCntAll_cbo;

            ChCntStr[0] = "1 Channel";
            ChCntStr[1] = "2 Channels";
            ChCntStr[2] = "3 Channels";
            ChCntStr[3] = "4 Channels";
            ChCntStr[4] = "5 Channels";
            ChCntStr[5] = "6 Channels";
            ChCntStr[6] = "7 Channels";
            ChCntStr[7] = "8 Channels";

            for (i = 0; i < 9; i++)
            {
                for (j = 0; j < 8; j++)
                {
                    chcnt_arr[i].Items.Add(ChCntStr[j]);
                }
            }
            for (i = 0; i < 8; i++)
            {
                this.chcnt_arr[i].SelectedIndexChanged += new System.EventHandler(this.ChCnt_SelectedIndexChanged);
            }
            //////////////////////////////////////
            SourceStr[0] = "Trig-Output Pin";
            SourceStr[1] = "Other device";

            for (i = 0; i < 2; i++)
            {
                Source_cbo.Items.Add(SourceStr[i]);
            }
            //////////////////////////////////////
            farm_arr[0] = Farm0_lab;
            farm_arr[1] = Farm1_lab;
            farm_arr[2] = Farm2_lab;
            farm_arr[3] = Farm3_lab;
            farm_arr[4] = Farm4_lab;
            farm_arr[5] = Farm5_lab;
            farm_arr[6] = Farm6_lab;
            farm_arr[7] = Farm7_lab;

            enable_arr[0] = En0_ckb;
            enable_arr[1] = En1_ckb;
            enable_arr[2] = En2_ckb;
            enable_arr[3] = En3_ckb;
            enable_arr[4] = En4_ckb;
            enable_arr[5] = En5_ckb;
            enable_arr[6] = En6_ckb;
            enable_arr[7] = En7_ckb;
            for (i = 0; i < 8; i++)
            {
                this.enable_arr[i].CheckStateChanged += new System.EventHandler(this.INIT_CheckBoxChecked);
            }

            target_arr[0] = Target0_txt;
            target_arr[1] = Target1_txt;
            target_arr[2] = Target2_txt;
            target_arr[3] = Target3_txt;
            target_arr[4] = Target4_txt;
            target_arr[5] = Target5_txt;
            target_arr[6] = Target6_txt;
            target_arr[7] = Target7_txt;
            for (i = 0; i < 8; i++)
            {
                this.target_arr[7].TextChanged += new System.EventHandler(this.Target_TextChanged);
            }

            //////////////////////////////////////
            for (i = 0; i < 8; i++)
            {
                Thread_flag[i] = false;
            }
            LibVer = pac8012WNet.pac8012W.LibVersion();
            LibVer_txt.Text = LibVer.ToString("X");
            LibDate = pac8012WNet.pac8012W.LibDate();
            LibDate_txt.Text = LibDate;
        }

        private void Search_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            int ret = 0;
            for (i = 0; i < 8; i++)
            {
                slotarr[i] = -1;
                ret = pac8012WNet.pac8012W.Init(i);
                if (ret == 0)
                {
                    slotarr[i] = 1;
                    slotcnt += 1;
                    FarmVer = pac8012WNet.pac8012W.FirmwareVersion(i);
                    farm_arr[i].Text = FarmVer.ToString();
                    this.enable_arr[i].CheckStateChanged -= new System.EventHandler(this.INIT_CheckBoxChecked);
                    enable_arr[i].Checked = true;
                    enable_arr[i].Enabled = true;
                    this.enable_arr[i].CheckStateChanged += new System.EventHandler(this.INIT_CheckBoxChecked);
                    farm_arr[i].Enabled = true;
                    range_arr[i].Enabled = true;
                    chcnt_arr[i].Enabled = true;
                    target_arr[i].Enabled = true;
                    if (!(Master_cbo.Items.Contains(SlotStr[i])))
                        Master_cbo.Items.Add(SlotStr[i]);
                }
                else
                {
                    enable_arr[i].Enabled = false;
                    farm_arr[i].Enabled = false;
                    range_arr[i].Enabled = false;
                    chcnt_arr[i].Enabled = false;
                    target_arr[i].Enabled = false;
                }
                Application.DoEvents();
            }
            if (slotcnt == 0)
            {
                MessageBox.Show("No modules on backplane");
                return;
            }
        }
        private void INIT_CheckBoxChecked(object sender, EventArgs e)
        {
            int ret = 0;
            int slot = 0;

            slot = int.Parse(((CheckBox)sender).Tag.ToString());

            if (((CheckBox)sender).Checked == true)
            {
                ret = pac8012WNet.pac8012W.Init(slot);
                if (ret == 0)
                {
                    slotarr[slot] = 1;
                    slotcnt += 1;
                    FarmVer = pac8012WNet.pac8012W.FirmwareVersion(slot);
                    farm_arr[slot].Text = FarmVer.ToString();
                    if (!(Master_cbo.Items.Contains(SlotStr[slot])))
                        Master_cbo.Items.Add(SlotStr[slot]);
                }
                else
                {
                    slotarr[slot] = -1;
                    slotcnt -= 1;
                    enable_arr[slot].Checked = false;
                    MessageBox.Show("No module on slot " + ((CheckBox)sender).Tag.ToString());

                }
            }
            else
            {
                slotarr[slot] = -1;
                slotcnt -= 1;
            }
        }

        private void RangeAll_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = 0;

            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    range_arr[i].SelectedIndex = RangeAll_cbo.SelectedIndex;
                    rangearr[i] = RangeAll_cbo.SelectedIndex;
                }
            }
        }
        private void Range_SelectedIndexChanged(object sender, EventArgs e)
        {
            int slot = 0;
            slot = int.Parse(((ComboBox)sender).Tag.ToString());
            if (slotarr[slot] == 1)
            {
                rangearr[slot] = ((ComboBox)sender).SelectedIndex;
            }
            else
            {
                MessageBox.Show("No module on slot " + ((ComboBox)sender).Tag.ToString());
                ((ComboBox)sender).SelectedIndex = -1;
            }
        }

        private void ChCntAll_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = 0;

            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    chcnt_arr[i].SelectedIndex = ChCntAll_cbo.SelectedIndex;
                    chcntarr[i] = ChCntAll_cbo.SelectedIndex + 1;
                }
            }
        }
        private void ChCnt_SelectedIndexChanged(object sender, EventArgs e)
        {
            int slot = 0;
            slot = int.Parse(((ComboBox)sender).Tag.ToString());
            if (slotarr[slot] == 1)
            {
                chcntarr[slot] = ((ComboBox)sender).SelectedIndex + 1;
            }
            else
            {
                MessageBox.Show("No module on slot " + ((ComboBox)sender).Tag.ToString());
                ((ComboBox)sender).SelectedIndex = -1;
            }
        }

        private void TargetAll_txt_TextChanged(object sender, EventArgs e)
        {
            int i = 0;
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    target_arr[i].Text = ((TextBox)sender).Text;
                }
                Application.DoEvents();
            }
        }
        private void Target_TextChanged(object sender, EventArgs e)
        {
            int slot = 0;
            slot = int.Parse(((TextBox)sender).Tag.ToString());
            if (slotarr[slot] != 1 && ((TextBox)sender).Text != "")
            {
                MessageBox.Show("No module on slot " + ((TextBox)sender).Tag.ToString());
                ((TextBox)sender).Text = "";
            }
        }

        private void Source_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            Description_list.Items.Clear();
            ext_source = Source_cbo.SelectedIndex;
            if (ext_source == 0)
            {
                Description_list.Items.Add("4.Input sample rate between 20~200K Hz");
                Description_list.Items.Add("  and select one module as Master card");
                Master_lab.Enabled = true;
                Master_cbo.Enabled = true;
                Sample_Rate_lab.Enabled = true;
                Sample_Rate_txt.Enabled = true;
            }
            else
            {
                Description_list.Items.Add("4.Connect external source to Trig-Input pin of");
                Description_list.Items.Add("  each module before start and Click 'Set' button");
                Master_lab.Enabled = false;
                Master_cbo.Enabled = false;
                Sample_Rate_lab.Enabled = false;
                Sample_Rate_txt.Enabled = false;
            }
        }

        private void Master_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            Description_list.Items.Add("5.Connect Trig-Output pin of master card to");
            Description_list.Items.Add("  Trig-Input pin of each module(include itself) and click 'Set' button");
            switch (Master_cbo.Text)
            {
                case "Slot 0":
                    Master_Card = 0;
                    break;

                case "Slot 1":
                    Master_Card = 1;
                    break;

                case "Slot 2":
                    Master_Card = 2;
                    break;

                case "Slot 3":
                    Master_Card = 3;
                    break;

                case "Slot 4":
                    Master_Card = 4;
                    break;

                case "Slot 5":
                    Master_Card = 5;
                    break;

                case "Slot 6":
                    Master_Card = 6;
                    break;

                case "Slot 7":
                    Master_Card = 7;
                    break;
            }
        }

        private void Set_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            UInt32 real_rate = 0;
            sample_rate = Convert.ToUInt32(Sample_Rate_txt.Text);
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    pac8012WNet.pac8012W.ConfigMagicScan(i, rangearr[i], chcntarr[i], trigmode, sample_rate, ref real_rate);
                }
            }
            if (ext_source == 0)
            {
                Description_list.Items.Add("6.Click 'Start' button");
            }
            else
            {
                Description_list.Items.Add("5.Click 'Start' button");
                Description_list.Items.Add("  and output external source");
            }
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            int j = 0;
            int mainstatus = 0;
            UInt32 datasize = 0;

            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    targetarr[i] = UInt32.Parse(target_arr[i].Text);
                    if ((targetarr[i] % chcntarr[i]) != 0)
                    {
                        datasize = (UInt32)(targetarr[i] / chcntarr[i]) + 1;
                        RawData[i] = new short[datasize * chcntarr[i]];
                    }
                    else
                        RawData[i] = new short[targetarr[i]];

                    HexData[i] = new short[chcntarr[i]][];
                    floatData[i] = new float[chcntarr[i]][];

                    for (j = 0; j < chcntarr[i]; j++)
                    {
                        if ((targetarr[i] % chcntarr[i]) != 0)
                        {
                            HexData[i][j] = new short[(targetarr[i] / chcntarr[i]) + 1];
                            floatData[i][j] = new float[(targetarr[i] / chcntarr[i]) + 1];
                        }
                        else
                        {
                            HexData[i][j] = new short[targetarr[i] / chcntarr[i]];
                            floatData[i][j] = new float[targetarr[i] / chcntarr[i]];
                        }
                    }
                    pac8012WNet.pac8012W.StartMagicScan(i);
                    //////////////////////////////////////
                    switch (i)
                    {
                        case 0:
                            myThreads[0] = new ThreadStart(Read_Data_slot0);
                            Threads[0] = new Thread(myThreads[0]);
                            break;
                        case 1:
                            myThreads[1] = new ThreadStart(Read_Data_slot1);
                            Threads[1] = new Thread(myThreads[1]);
                            break;

                        case 2:
                            myThreads[2] = new ThreadStart(Read_Data_slot2);
                            Threads[2] = new Thread(myThreads[2]);
                            break;

                        case 3:
                            myThreads[3] = new ThreadStart(Read_Data_slot3);
                            Threads[3] = new Thread(myThreads[3]);
                            break;

                        case 4:
                            myThreads[4] = new ThreadStart(Read_Data_slot4);
                            Threads[4] = new Thread(myThreads[4]);
                            break;

                        case 5:
                            myThreads[5] = new ThreadStart(Read_Data_slot5);
                            Threads[5] = new Thread(myThreads[5]);
                            break;

                        case 6:
                            myThreads[6] = new ThreadStart(Read_Data_slot6);
                            Threads[6] = new Thread(myThreads[6]);
                            break;

                        case 7:
                            myThreads[7] = new ThreadStart(Read_Data_slot7);
                            Threads[7] = new Thread(myThreads[7]);
                            break;
                    }
                    totalcount[i] = 0;
                    Thread_flag[i] = true;
                    Threads[i].Start();
                    threadstatusarr[i] = 1;
                    mainstatus |= 1 << i;
                }
            }


            if (ext_source == 0)
                pac8012WNet.pac8012W.EnableTrigOut(Master_Card);

            flag = true;
            while (flag)
            {
                for (i = 0; i < 8; i++)
                {
                    if (slotarr[i] == 1)
                    {
                        if (threadstatusarr[i] != 1)
                            mainstatus &= ~(1 << i);
                    }
                }
                if (mainstatus == 0)
                {
                    flag = false;
                    pac8012WNet.pac8012W.DisableTrigOut(Master_cbo.SelectedIndex);
                    Description_list.Items.Clear();
                    Description_list.Items.Add("Scan Finished");
                    Show_AI();
                    break;
                }
                Application.DoEvents();
            }
        }

        private void Clear_Desc_btn_Click(object sender, EventArgs e)
        {
            Description_list.Items.Clear();
        }

        private void Clear_Data_btn_Click(object sender, EventArgs e)
        {
            Data_list.Items.Clear();
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            Close();
        }
        
        private void Read_Data_slot0()
        {
            int ret = 0;
            int slot = 0;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);
                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot1()
        {
            int ret = 0;
            int slot = 1;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot2()
        {
            int ret = 0;
            int slot = 2;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot3()
        {
            int ret = 0;
            int slot = 3;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot4()
        {
            int ret = 0;
            int slot = 4;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot5()
        {
            int ret = 0;
            int slot = 5;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot6()
        {
            int ret = 0;
            int slot = 6;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        private void Read_Data_slot7()
        {
            int ret = 0;
            int slot = 7;
            int i = 0;
            short[] FIFOData = new short[2100];
            short read_count = 0;

            totalcount[slot] = 0;
            for (; ; )
            {
                if (Thread_flag[slot])
                {
                    ret = pac8012WNet.pac8012W.ReadFIFONonBlock(slot, FIFOData, targetarr[slot] - totalcount[slot], ref read_count);
                    if (ret == (int)pac8012WNet.ErrorCode.FIFO_FULL)
                    {
                        pac8012WNet.pac8012W.StopMagicScan(slot);

                        threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.FIFO_FULL;
                        Thread_flag[slot] = false;
                        return;
                    }
                    if (ret == (int)pac8012WNet.ErrorCode.NoError)
                    {
                        for (i = 0; i < read_count; i++)
                            RawData[slot][i + totalcount[slot]] = FIFOData[i];
                        totalcount[slot] += (UInt32)read_count;
                        if (totalcount[slot] >= targetarr[slot])
                        {
                            pac8012WNet.pac8012W.StopMagicScan(slot);
                            threadstatusarr[slot] = (int)pac8012WNet.ErrorCode.NoError;
                            Thread_flag[slot] = false;
                            return;
                        }
                    }
                }
                else
                    return;
            }
        }

        void Show_AI()
        {
            int ch = 0;
            int i = 0;
            UInt32 j = 0;
            string Msg = "";
            UInt32 DataCount = 0;
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    if (totalcount[i] < targetarr[i])
                    {
                        Msg = string.Format("Slot {0} FIFO full!! Please use a lower rate and try again", i);
                        MessageBox.Show(Msg);
                        continue;
                    }
                    Data_list.Items.Add("Slot " + i);

                    if ((targetarr[i] % chcntarr[i]) != 0)
                        DataCount = (UInt32)((targetarr[i] / chcntarr[i]) + 1);
                    else
                        DataCount = (UInt32)(targetarr[i] / chcntarr[i]);
                    for (j = 0; j < DataCount; j++)
                    {
                        for (ch = 0; ch < chcntarr[i]; ch++)
                        {
                            pac8012WNet.pac8012W.CalibrationHEX(i, ch, rangearr[i], RawData[i][j * chcntarr[i] + ch], ref HexData[i][ch][j]);
                            pac8012WNet.pac8012W.CalibrationFloat(i, ch, rangearr[i], RawData[i][j * chcntarr[i] + ch], ref floatData[i][ch][j]);
                            Application.DoEvents();
                        }
                    }
                    for (j = 0; j < DataCount; j++)
                    {
                        Msg = "[" + j.ToString("0000") + "] ";
                        for (ch = 0; ch < chcntarr[i]; ch++)
                        {
                            if (ch % chcntarr[i] == chcntarr[i] - 1)
                                Msg += "CH_" + ch.ToString() + " " + HexData[i][ch][j].ToString("X") + " " + floatData[i][ch][j].ToString("00.000");
                            else
                                Msg += "CH_" + ch.ToString() + " " + HexData[i][ch][j].ToString("X") + " " + floatData[i][ch][j].ToString("00.000") + ", ";
                        }
                        Data_list.Items.Add(string.Format(Msg));
                        Application.DoEvents();
                    }
                }
            }
        }

        private void Save_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            int i = 0;
            UInt32 j = 0;
            string fPath = GetAppPath() + "\\SampleData" + ".txt";
            string data = string.Empty;
            Description_list.Items.Add(fPath);
            StreamWriter Dsw = new StreamWriter(fPath, false, System.Text.Encoding.Default);
            Dsw.WriteLine("HEX Format");
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    Dsw.WriteLine("slot " + i.ToString());
                    for (j = 0; j < targetarr[i] / chcntarr[i]; j++)
                    {
                        data = string.Empty;
                        for (ch = 0; ch < chcntarr[i]; ch++)
                        {
                            if (ch % chcntarr[i] == chcntarr[i] - 1)
                                data += HexData[i][ch][j].ToString("X");
                            else
                                data += HexData[i][ch][j].ToString("X") + ", ";
                        }
                        Dsw.WriteLine(data);
                    }
                }
            }
            Dsw.WriteLine("Float Format");
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                {
                    Dsw.WriteLine("slot " + i.ToString());
                    for (j = 0; j < targetarr[i] / chcntarr[i]; j++)
                    {
                        data = string.Empty;
                        for (ch = 0; ch < chcntarr[i]; ch++)
                        {
                            if (ch % chcntarr[i] == chcntarr[i] - 1)
                                data += floatData[i][ch][j].ToString("00.000");
                            else
                                data += floatData[i][ch][j].ToString("00.000") + ",";
                        }
                        Dsw.WriteLine(data);
                    }
                }
            }
            Dsw.Flush();
            Dsw.Close();
        }

        private string GetAppPath()
        {
            int iStart = 0;
            string csCurDir = "";
            System.Text.StringBuilder STRBER = new System.Text.StringBuilder(256);
            if (GetModuleFileName(IntPtr.Zero, STRBER, STRBER.Capacity) > 0)
                csCurDir = STRBER.ToString();
            else
                return string.Empty;
            while (!csCurDir.EndsWith(@"\"))
            {
                iStart = csCurDir.Length - 1;
                csCurDir = csCurDir.Remove(iStart, 1);
            }
            return csCurDir;
        }

        private void Stop_btn_Click(object sender, EventArgs e)
        {
            int i = 0;
            flag = false;
            for (i = 0; i < 8; i++)
            {
                if (slotarr[i] == 1)
                    Thread_flag[i] = false;
            }
        }
    }
}